package lib.print;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.print.*;
import javax.swing.*;
import javax.swing.border.*;

//      
class ScreenPrint extends JDialog implements ActionListener, WindowListener {

	//   
	//   ""
	static final int CANCEL = 0;
	
	//   ,      
	static final int OK = 1;
	
	//           
	static final int REVERSE = -1 ;
	
	//  
	private int indexPage;
	
	//  
	private int maxIngexPange;
	
	//  
	private JButton button_1;
	private JButton button_2;
	private JButton button_3;
	
	//   
	private JCheckBox checkBox;
	
	//   
	private PagePanel pagePanel;
	
	//   
	private JLabel labelIndex;
	
	// 
	private int userSelect;
	
	//  
	private boolean flagThread;
	
	//        
	// show
	private ScreenPrint(Frame owner, TablePrint tablePrint, PageFormat pageFormat) {
		super(owner, " ");
		indexPage = -1;
		maxIngexPange = tablePrint.maxPageIndex();
		userSelect = OK;
		flagThread = true;
		
		BevelBorder border_1 = new BevelBorder(BevelBorder.LOWERED);
		BevelBorder border_2 = new BevelBorder(BevelBorder.LOWERED);
		pagePanel = new PagePanel(tablePrint,pageFormat, maxIngexPange == -1 ? false : true);
		JScrollPane scrollPane = new JScrollPane(pagePanel);
		scrollPane.setBorder(border_1);
		button_1 = new JButton("");
		button_2 = new JButton("");
		button_3 = new JButton("");
		JButton button_4 = new JButton("");
		labelIndex = new JLabel("  1");
		checkBox = new JCheckBox("   ", false);
		JPanel panel = new JPanel();
		
		panel.setLayout(new FlowLayout(FlowLayout.CENTER,10,10));
		panel.setBorder(border_2);
		
		panel.add(labelIndex);
		panel.add(button_1);
		panel.add(button_2);
		panel.add(button_3);
		panel.add(checkBox);
		panel.add(button_4);
		
		setLayout(new BorderLayout(5,5));
		add(scrollPane,BorderLayout.CENTER);
		add(panel, BorderLayout.SOUTH);
		
		//         
		button_1.addActionListener(this);
		button_2.addActionListener(this);
		button_3.addActionListener(this);
		button_4.addActionListener(this);
		checkBox.addActionListener(this);
		
		setDefaultCloseOperation (JDialog.DO_NOTHING_ON_CLOSE);
		
		//   
		addWindowListener(this);
		
		//   
		pack();
		
		//    
		Dimension dimension = getSize();
		int heigth = (int)dimension.getHeight();
		int width = (int)dimension.getWidth();
		if ( heigth > 600)
			setSize(width,600);
		//  
		vaul(true);
		
		// 
		setVisible(true);
		
		//  
		while(flagThread)
			try{
				Thread.currentThread().sleep(100);
			}catch(InterruptedException e) {;}
	}
	
	static int show(Frame owner,TablePrint tablePrint, PageFormat pageFormat) {
		ScreenPrint screenPrint = new ScreenPrint(owner,tablePrint,pageFormat);
		int n = screenPrint.userSelect;
		screenPrint.dispose();
		return n;
	}
	
	//  ActionListener
	public void actionPerformed(ActionEvent event) {	
		Object o = event.getSource();
		String s ;
		o = event.getSource();
		if(o instanceof JButton)
			s = ((JButton)o).getLabel();
		else
			s = ((JCheckBox)o).getLabel();
		
		if(s.equals("")) {
			vaul(false);
			return;
		}
		if(s.equals("")) {
			vaul(true);
			return;
		}
		if(s.equals("")) {
			flagThread = false;
			return;
		}
		if(s.equals("")) {
			userSelect = CANCEL;
			flagThread = false;
		}
		if(s.equals("   "))
			if (userSelect == OK)
				userSelect = REVERSE;
			else
				userSelect = OK;
	}
	
	//     Printable,   
	//       ,
	private void vaul(boolean b) {
		if(b) 
			pagePanel.setPageIndex( ++ indexPage);
		else 
			pagePanel.setPageIndex( -- indexPage);
		labelIndex.setText("  " + (indexPage + 1));
		
		//  maxIngexPange = -1       
		//  ""    
		if(maxIngexPange == -1) {
			button_3.setEnabled(false);
			checkBox.setEnabled(false);
		}
		
		//        
		if(indexPage == 0)
				button_1.setEnabled(false);
		else
			button_1.setEnabled(true);
				
		if(indexPage >= maxIngexPange)
			button_2.setEnabled(false);
		else
			button_2.setEnabled(true);
	}
	
    //      false
    public void windowClosing ( WindowEvent  ) {
		 userSelect = CANCEL;
		 flagThread = false;
        }
	public void windowActivated ( WindowEvent  ){;}
    public void windowClosed ( WindowEvent  ){;}
    public void windowDeactivated ( WindowEvent  ){;}
    public void windowDeiconified ( WindowEvent  ){;}
    public void windowIconified ( WindowEvent  ){;}
    public void windowOpened ( WindowEvent  ){;}
}